<?php
/**
 * Generate our Domain Notification admin page.
 */
function domain_notification_admin() {
  $form = array();
  
  $form['domain_notification_first_period'] = array(
    '#type' => 'textfield',
    '#title' => 'First notification period for empty domains (-1 week)',
    '#default_value' => variable_get('domain_notification_first_period', '-1 week'),
    '#required' => TRUE,
  );
  $form['domain_notification_first_message_subject'] = array(
    '#type' => 'textfield',
    '#title' => t('Subject of the first period notification message'),
    '#default_value' => variable_get('domain_notification_first_message_subject', 'First notification from !site'),
    '#required' => TRUE,
  );
  $form['domain_notification_first_message_body'] = array(
    '#type' => 'textarea',
    '#title' => t('First period notification message'),
    '#default_value' => variable_get('domain_notification_first_message_body', 'Dear !username,\n\nYou have not posted in your blog for a week now. The blog will be removed after 1 month of inactivity.'),
    '#required' => TRUE,
  );
  $form['domain_notification_second_period'] = array(
    '#type' => 'textfield',
    '#title' => 'Second notification period for empty domains (-3 weeks)',
    '#default_value' => variable_get('domain_notification_second_period', '-3 weeks'),
    '#required' => TRUE,
  );
  $form['domain_notification_second_message_subject'] = array(
    '#type' => 'textfield',
    '#title' => t('Subject of the second period notification message'),
    '#default_value' => variable_get('domain_notification_second_message_subject', 'Second notification from !site'),
    '#required' => TRUE,
  );
  $form['domain_notification_second_message_body'] = array(
    '#type' => 'textarea',
    '#title' => t('Second period notification message'),
    '#default_value' => variable_get('domain_notification_second_message_body', 'Dear !username,\n\nYou have not posted in your blog for 3 weeks now. You have one more week to post in it, or it will be removed.'),
    '#required' => TRUE,
  );
  $form['domain_notification_third_period'] = array(
    '#type' => 'textfield',
    '#title' => 'Third notification period for empty domains (-1 month)',
    '#default_value' => variable_get('domain_notification_third_period', '-1 month'),
    '#required' => TRUE,
  );
  $form['domain_notification_third_message_subject'] = array(
    '#type' => 'textfield',
    '#title' => t('Subject of the third period notification message'),
    '#default_value' => variable_get('domain_notification_third_message_subject', 'Third notification from !site'),
    '#required' => TRUE,
  );
  $form['domain_notification_third_message_body'] = array(
    '#type' => 'textarea',
    '#title' => t('Third period notification message'),
    '#default_value' => variable_get('domain_notification_third_message_body', "Dear !username,\n\nSince you didn't use your blog for a month, it was automatically deleted. You may create a new one if you want to."),
    '#required' => TRUE,
  );
  $form['domain_notification_delete_third'] = array(
    '#type' => 'checkbox',
    '#title' => t('Delete the domain after third warning?'),
    '#default_value' => variable_get('domain_notification_delete_third', '1'),
    '#required' => TRUE,
  );
  return system_settings_form($form);
}

/**
 * Validate the user input for Domain Notifier settings.
 */
function domain_notification_admin_validate($form, &$form_state) {
  $first = $form_state['values']['domain_notification_first_period'];
  $second = $form_state['values']['domain_notification_second_period'];
  $third = $form_state['values']['domain_notification_third_period'];
  if(($timestamp = strtotime($first)) === FALSE) {
    form_set_error('domain_notification_first_period', t('You must enter a valid string for strtotime()'));
  } elseif (($timestamp = strtotime($first)) >= time()) {
    form_set_error('domain_notification_first_period', t('Supplied time must be in the past'));
  }
  if(($timestamp = strtotime($second)) === FALSE) {
    form_set_error('domain_notification_second_period', t('You must enter a valid string for strtotime()'));
  } elseif (($timestamp = strtotime($second)) >= time()) {
    form_set_error('domain_notification_second_period', t('Supplied time must be in the past'));
  }
  if(($timestamp = strtotime($third)) === FALSE) {
    form_set_error('domain_notification_third_period', t('You must enter a valid string for strtotime()'));
  } elseif (($timestamp = strtotime($third)) >= time()) {
    form_set_error('domain_notification_third_period', t('Supplied time must be in the past'));
  }
}